unit Stat_pgm;

interface

uses
  DisplayUnit,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, see, StdCtrls;

type
  TStatus = class(TForm)
    MainMenu1: TMainMenu;
    mConnect: TMenuItem;
    mCheckMail: TMenuItem;
    mExit: TMenuItem;
    eMessage: TMemo;
    lUser: TLabel;
    lServer: TLabel;
    lPass: TLabel;
    eHost: TEdit;
    eUser: TEdit;
    ePass: TEdit;
    procedure mExitClick(Sender: TObject);
    procedure mConnectClick(Sender: TObject);
    procedure mCheckMailClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Status: TStatus;
  D1, D2, D3 : Integer;
  Code : Integer;

implementation

{$R *.DFM}

procedure TStatus.mExitClick(Sender: TObject);
begin
  seeClose;
  Application.Terminate;
end;

procedure TStatus.mConnectClick(Sender: TObject);
var
  Code : Integer;
  HostPtr : PChar;
  UserPtr : PChar;
  PassPtr : PChar;
  LogPtr  : PChar;
begin
  {show SEE version}
  Code := seeStatistics(SEE_GET_VERSION);
  D3 := $0F AND Code;  Code := Code SHR 4;
  D2 := $0F AND Code;  Code := Code SHR 4;
  D1 := $0F AND Code;
  DisplayLine(Status.eMessage,'SMTP/POP3 Email Engine Version '
            + Chr(48 + D1)
            + '.' + Chr(48 + D2)
            + '.' + Chr(48 + D3));
  {do we have all necessary parameters ?}
  if Length(eHost.Text) = 0 then
    begin
      DisplayLine(Status.eMessage,'POP3 Host is missing');
      exit;
    end;
  if Length(eUser.Text) = 0 then
    begin
      DisplayLine(Status.eMessage,'User is missing');
      exit;
    end;
  if Length(ePass.Text) = 0 then
    begin
      DisplayLine(Status.eMessage,'Password is missing');
      exit;
    end;
  {define log file}
  GetMem(LogPtr,32); StrPCopy(LogPtr, 'STATUS.LOG');
  seeStringParam(SEE_LOG_FILE, LogPtr); FreeMem(LogPtr, 32);
  {do we have all necessary parameters ?}
  {allocate buffers}
  GetMem(HostPtr, 64); StrPCopy(HostPtr, eHost.Text);
  GetMem(UserPtr, 64); StrPCopy(UserPtr, eUser.Text);
  GetMem(PassPtr, 64); StrPCopy(PassPtr, ePass.Text);
  {connect to POP3 server}
  Code := seePop3Connect(HostPtr, UserPtr, PassPtr);
  {free buffers}
  FreeMem(HostPtr,64); FreeMem(UserPtr,64); FreeMem(PassPtr,64);
  {any errors ?}
  If Code < 0 then
    begin
      DisplayError(eMessage, Code);
      seeClose;
    end;
  {ready to check mail}
  DisplayLine(Status.eMessage,'Connected. Ready to CheckMail.');
  mConnect.Enabled := false;
  mCheckmail.Enabled := true;
end;

procedure TStatus.mCheckMailClick(Sender: TObject);
var
  I, N : Integer;
  Code : Integer;
  NbrMsg : Integer;
  TempPtr  : PChar;
  BufferPtr : PChar;
  DatePtr : PChar;
  FromPtr : PChar;
  SubjPtr : PChar;
begin
 { get # messages waiting on server}
 DisplayLine(Status.eMessage,'Getting message count...');
 NbrMsg := seeGetEmailCount;
 if NbrMsg < 0 then DisplayError(Status.eMessage,NbrMsg);
 DisplayLine(Status.eMessage,Format('%d messages waiting.',[NbrMsg]));
 {construct pointers to strings}
 GetMem(BufferPtr, 1024);
 GetMem(TempPtr, 80);
 GetMem(DatePtr,8);  StrPCopy(DatePtr,'Date: ');
 GetMem(FromPtr,8);  StrPCopy(FromPtr,'From: ');
 GetMem(SubjPtr,12); StrPCopy(SubjPtr,'Subject: ');
 mCheckmail.Enabled := false;
 { read message headers }
 for I := 1 to NbrMsg do
   begin
     {read message I}
     DisplayLine(Status.eMessage,
       Format('---[ Message %d ]------------------------------------',[I]));
     Code := seeGetEmailLines(I, 0, BufferPtr, 1024);
     if Code < 0 then DisplayError(Status.eMessage,Code);
     {display 'DATE: ' line}
     n := seeExtractText(BufferPtr, DatePtr, TempPtr, 80);
     if n > 0  then DisplayString(Status.eMessage,
       Format('%s', [StrPas(TempPtr)]));
     {display 'FROM: ' line}
     n := seeExtractText(BufferPtr, FromPtr, TempPtr, 80);
     if n > 0  then DisplayString(Status.eMessage,
       Format('%s', [StrPas(TempPtr)]));
     {display 'SUBJECT: ' line}
     n := seeExtractText(BufferPtr, SubjPtr, TempPtr, 80);
     if n > 0  then DisplayString(Status.eMessage,
       Format('%s', [StrPas(TempPtr)]));
   end;
 mCheckmail.Enabled := true;
 DisplayLine(Status.eMessage,
    '-------------------------------------------------------');
 FreeMem(BufferPtr,1024);
 FreeMem(TempPtr,80); FreeMem(DatePtr,8);
 FreeMem(FromPtr,8);  FreeMem(SubjPtr,12);
end;

end.
